---
title: Array.prototype.reverse()
slug: Web/JavaScript/Reference/Global_Objects/Array/reverse
tags:
  - Array
  - JavaScript
  - Method
  - Prototype
---
<div>{{JSRef}}</div>

<p>The <strong><code>reverse()</code></strong> method reverses an array <em><a href="https://en.wikipedia.org/wiki/In-place_algorithm">in place</a></em>. The first array element becomes the last, and the last array element becomes the first.</p>

<div>{{EmbedInteractiveExample("pages/js/array-reverse.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>a</var>.reverse()</pre>

<h3 id="Return_value">Return value</h3>

<p>The reversed array.</p>

<h2 id="Description">Description</h2>

<p>The <code>reverse</code> method transposes the elements of the calling array object in place, mutating the array, and returning a reference to the array.</p>

<p><code>reverse</code> is intentionally generic; this method can be {{jsxref("Function.call", "called", "", 1)}} or {{jsxref("Function.apply", "applied", "", 1)}} to objects resembling arrays. Objects which do not contain a <code>length</code> property reflecting the last in a series of consecutive, zero-based numerical properties may not behave in any meaningful manner.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Reversing_the_elements_in_an_array">Reversing the elements in an array</h3>

<p>The following example creates an array <code>a</code>, containing three elements, then reverses the array. The call to <code>reverse()</code> returns a reference to the reversed array <code>a</code>.</p>

<pre class="brush: js notranslate">const a = [1, 2, 3];

console.log(a); // [1, 2, 3]

a.reverse();

console.log(a); // [3, 2, 1]

</pre>

<h3 id="Reversing_the_elements_in_an_array-like_object">Reversing the elements in an array-like object</h3>

<p>The following example creates an array-like object <code>a</code>, containing three elements and a length property, then reverses the array-like object. The call to <code>reverse()</code> returns a reference to the reversed array-like object <code>a</code>.</p>

<pre class="brush: js notranslate">const a = {0: 1, 1: 2, 2: 3, length: 3};

console.log(a); // {0: 1, 1: 2, 2: 3, length: 3}

Array.prototype.reverse.call(a); //same syntax for using apply()

console.log(a); // {0: 3, 1: 2, 2: 1, length: 3}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-array.prototype.reverse', 'Array.prototype.reverse')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Array.reverse")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.join()")}}</li>
 <li>{{jsxref("Array.prototype.sort()")}}</li>
 <li>{{jsxref("TypedArray.prototype.reverse()")}}</li>
</ul>
